package com.yolo.keyboard.service.userwallet;

import java.util.*;

import com.yolo.keyboard.dal.dataobject.userwallet.KeyboardWalletTransactionDO;
import jakarta.validation.*;
import com.yolo.keyboard.controller.admin.userwallet.vo.*;
import com.yolo.keyboard.dal.dataobject.userwallet.KeyboardUserWalletDO;
import com.yolo.keyboard.framework.common.pojo.PageResult;
import com.yolo.keyboard.framework.common.pojo.PageParam;

/**
 * 用户钱包 Service 接口
 *
 * @author ziin
 */
public interface KeyboardUserWalletService {

    /**
     * 创建用户钱包
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createUserWallet(@Valid KeyboardUserWalletSaveReqVO createReqVO);

    /**
     * 更新用户钱包
     *
     * @param updateReqVO 更新信息
     */
    void updateUserWallet(@Valid KeyboardUserWalletSaveReqVO updateReqVO);

    /**
     * 删除用户钱包
     *
     * @param id 编号
     */
    void deleteUserWallet(Long id);

    /**
    * 批量删除用户钱包
    *
    * @param ids 编号
    */
    void deleteUserWalletListByIds(List<Long> ids);

    /**
     * 获得用户钱包
     *
     * @param id 编号
     * @return 用户钱包
     */
    KeyboardUserWalletDO getUserWallet(Long id);

    /**
     * 获得用户钱包分页
     *
     * @param pageReqVO 分页查询
     * @return 用户钱包分页
     */
    PageResult<KeyboardUserWalletDO> getUserWalletPage(KeyboardUserWalletPageReqVO pageReqVO);
// ==================== 子表（钱包交易记录） ====================

    /**
     * 获得钱包交易记录分页
     *
     * @param pageReqVO 分页查询
     * @param userId 用户 Id
     * @return 钱包交易记录分页
     */
    PageResult<KeyboardWalletTransactionDO> getWalletTransactionPage(PageParam pageReqVO, Long userId);

    /**
     * 创建钱包交易记录
     *
     * @param walletTransaction 创建信息
     * @return 编号
     */
    Long createWalletTransaction(@Valid KeyboardWalletTransactionDO walletTransaction);

    /**
     * 更新钱包交易记录
     *
     * @param walletTransaction 更新信息
     */
    void updateWalletTransaction(@Valid KeyboardWalletTransactionDO walletTransaction);

    /**
     * 删除钱包交易记录
     *
     * @param id 编号
     */
    void deleteWalletTransaction(Long id);

    /**
     * 批量删除钱包交易记录
     *
     * @param ids 编号
     */
    void deleteWalletTransactionListByIds(List<Long> ids);

    /**
     * 获得钱包交易记录
     *
     * @param id 编号
     * @return 钱包交易记录
     */
    KeyboardWalletTransactionDO getWalletTransaction(Long id);
}